# Script to test submissions

## Kesako

This script is meant to be used to automatically run tests on the students submissions for the *Computer Language Processing* course.

## Usage

To run this script, you first have to set two variables located at the top of it:
- `CLPSPEC_DIR` which is the path to your local copy of the **CLPSPEC repo**, which will be used to run the tests;
- `TEST_SET` which indicates which tests to run (the lab number). Only the first 3 labs are currently supported as of now.

The script expects to be in the same directory as the archive generated by moodle.
The archive is expected to be the archive containing **all** the submissions to grade,
which is generated when bulk downloading submissions.

The script will output 3 files for each group:
- `<group>.out` the result of running the tests on the submission;
- `<group>.isolated.out` same as above, but the files from previous labs are replaced by the one of the reference compiler;
- `<group>.diff` the git diff between the students' implementation and the reference. It only contains the file relevant to the current lab, and might be useless, depending on git's mood and the lab being tested.

The script will also generate a directory containing the source code of the group.

## Q&A

*I get `Please clean the working tree of CLPSPECS`*: you should clean the CLPSPEC repo (i.e. remove all the uncommited changes). If you're sure that you have nothing important which is not commited, you can do this using `git checkout -- .` and `git clean -f`.

